/*
    Copyright (C) 2004 Adam Olsen

	This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <sqlitem/sqliteresult.hpp>

namespace sqlitem
{
	int SQliteCallback( void *argument, int argc, char **argv, char **columns )
	{
		SQliteResult *res = (SQliteResult *)argument;
		std::string firstColumn( columns[0] );
		std::map< std::string, std::string > *currentRow = 0;
		res->currRow = 0;

		for( int i = 0; i < argc; i++ )
		{
			if( strcmp( columns[i], firstColumn.c_str() ) == 0 )
			{
				if( currentRow )
				{
					res->results.push_back( *currentRow );
					delete currentRow;
					currentRow = 0;
				}

				currentRow = new std::map<std::string, std::string>;
				res->rowCount++;
				res->currRow++;
			}

			std::string column = columns[i];

			(*currentRow)[column] = argv[i];
		}

		if( currentRow )
		{
			res->results.push_back( *currentRow );
			delete currentRow;
		}

		res->currRow--;

		return 0;
	}

	void SQliteResult::reset()
	{
		currRow = rowCount - 1;
	}

	void SQliteResult::finalize()
	{
		manager.freeResult( this );
	}

	SQliteResult::SQliteResult( SQliteManager manager )
	{
		this->manager = manager;
		rowCount = 0;
		currRow = -1;
	}

	bool SQliteResult::hasNext()
	{
		if( currRow < 0 ) return false;
		else return true;
	}

	std::map<std::string, std::string> SQliteResult::next()
	{
		return results[currRow--];
	}
}
